
//+-----------------------------------------------------------------------+
//|                                      !XARD GOLDBANDS  \/             |
//|                            Knowledge of the ancients ( )            |
//|_________________________________________________o0o___(_)___o0o_______|
//|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|
//|                                                            by XARD777 |
//|-----------------------------------------------------------------------|
//| Programming language: MQL4                                            |
//| Development platform: MetaTrader 4                                    |
//|          End product: Indicator for MetaTrader 4 designed             |
//|                       for Build 226 (current version)                 |
//+-----------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 White
#property indicator_width1 2
#property indicator_color2 White
#property indicator_width2 2
#property indicator_color3 Blue
#property indicator_width3 4
#property indicator_color4 Gold
#property indicator_width4 4 

extern int     Length         =  21;
extern int     Shuffle        =  12;
extern double  Deviation      =  3.0;

extern bool   AlertsOn        = true;
extern bool   AlertsOnCurrent = true;
extern bool   AlertsMessage   = false;
extern bool   AlertsSound     = true;
extern bool   AlertsEmail     = false;

int shift1 = 0;
int shift = 0;
double Bands[];
double Base_Signal[];
double Center_UP[];
double Center_DN[];
double Upper_Band[];
double Lower_Band[];
double trend[];

int TimeFrame;
string tf;
string Copyright = "FX GOLD  2011";

//+-----------------------------------------------------------------------+

int init() {
   IndicatorBuffers(7);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexShift(0, shift);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexShift(1, shift);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexShift(2, shift);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexShift(3, shift);
   SetIndexStyle(4, DRAW_NONE);
   SetIndexShift(4, shift);
   SetIndexStyle(5, DRAW_NONE);
   SetIndexShift(5, shift);
   SetIndexBuffer(6,trend);
   
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   
   if (Length < 2) Length = 12;
   int i = Length - 1;
   string name = "GoldBands(";
   
   IndicatorShortName(name + Length + ")");
   SetIndexDrawBegin(0, i);
   SetIndexBuffer(0, Upper_Band);
   SetIndexDrawBegin(1, i);
   SetIndexBuffer(1, Lower_Band);
   SetIndexDrawBegin(2, i);
   SetIndexBuffer(2, Center_UP);
   SetIndexDrawBegin(3, i);
   SetIndexBuffer(3, Center_DN);
   SetIndexDrawBegin(4, i);
   SetIndexBuffer(4, Bands);
   SetIndexDrawBegin(5, i);
   SetIndexBuffer(5, Base_Signal);
   
   
     	switch(TimeFrame)
	{
		case 1:		tf=" M1";  break;
		case 5:		tf=" M5";  break;
		case 15:		tf=" M15"; break;
		case 30:		tf=" M30"; break;
		case 60:		tf=" H1";  break;
		case 240:	tf=" H4";  break;
		case 1440:	tf=" D1";  break;
		case 10080:	tf=" W1";  break;
		case 43200:	tf=" MN1"; break;
		default:	  {TimeFrame = Period(); init(); return(0);}
	
	}
   
   return (0);
   }

//+-----------------------------------------------------------------------+

   int deinit() {
   ObjectsDeleteAll(1,OBJ_LABEL);
   return (0);
   }

//+-----------------------------------------------------------------------+

   int start() {
   int x;
   double dev;
   double total;
   double signal;
   double sum2;
   
   Gold_Bands();
   sma();
   
   if (Bars <= Shuffle) return (0);
   int counted_bars = IndicatorCounted();
   for (int i = 1; i <= Shuffle; i++) {
      Base_Signal[Bars - i] = EMPTY_VALUE;
      Upper_Band[Bars - i] = EMPTY_VALUE;
      Lower_Band[Bars - i] = EMPTY_VALUE;
      Center_UP[Bars - i] = EMPTY_VALUE;
      Center_DN[Bars - i] = EMPTY_VALUE;
   }
   int limit = Bars - counted_bars;
   if (counted_bars > 0) limit++;
   i = Bars - Shuffle + 1;
   if (counted_bars > Shuffle - 1) i = Bars - counted_bars - 1;
   while (i >= 0) {
      total = 0.0;
      x = i + Shuffle - 1;
      signal = Base_Signal[i];
      while (x >= i) {
         sum2 = Bands[x] - signal;
         total += sum2 * sum2;
         x--;
      }
      dev = Deviation * MathSqrt(total / Shuffle);
      Upper_Band[i] = signal + dev;
      Lower_Band[i] = signal - dev;
      i--;
   }
   i = Bars - Shuffle + 1;
   if (counted_bars > Shuffle - 1) i = Bars - counted_bars - 1;
   while (i >= 0) { 
       trend[i] = trend[i+1];
   if (Base_Signal[i] < Bands[i]) {
       Center_UP[i] = Base_Signal[i];
       Center_DN[i] = EMPTY_VALUE;
   if(Center_UP[i]== Base_Signal[i] && Center_DN[i]== EMPTY_VALUE)trend[i] =  1;    
   if (Center_UP[i + 1] == EMPTY_VALUE) Center_UP[i + 1] = Base_Signal[i + 1];
      } else { 
       trend[i] = trend[i+1];
   if (Base_Signal[i] > Bands[i]) {
       Center_DN[i] = Base_Signal[i];
       Center_UP[i] = EMPTY_VALUE;
   if(Center_DN[i]== Base_Signal[i] && Center_UP[i]== EMPTY_VALUE)trend[i] = -1;       
   if (Center_DN[i + 1] == EMPTY_VALUE) Center_DN[i + 1] = Base_Signal[i + 1];
         }
     
      }
      i--;
      
      manageAlerts();
   }
   return (0);
}

//+-----------------------------------------------------------------------+

void Gold_Bands() {
   double close;
   double sum = 0.0;
   double Band2 = 0.0;
   int bars = 0;
   int limit3 = Bars - shift1 - 1;
   if (limit3 < Length) limit3 = Length;
   int j = 1;
   while (j <= Length) {
      close = Close[limit3];
      sum += close * j;
      Band2 += close;
      bars += j;
      j++;
      limit3--;
   }
   limit3++;
   j = limit3 + Length;
   while (limit3 >= 0) {
      Bands[limit3] = sum / bars;
      if (limit3 == 0) break;
      limit3--;
      j--;
      close = Close[limit3];
      sum = sum - Band2 + close * Length;
      Band2 -= Close[j];
      Band2 += close;
   }
   if (shift1 < 1) for (j = 1; j < Length; j++) Bands[Bars - j] = 0;
}

//+-----------------------------------------------------------------------+

void sma() {
   double sum = 0;
   int limit2 = Bars - shift1 - 1;
   if (limit2 < Shuffle) limit2 = Shuffle;
   int k = 1;
   while (k < Shuffle) {
      sum += Bands[limit2];
      k++;
      limit2--;
   }
   while (limit2 >= 0) {
      sum += Bands[limit2];
      Base_Signal[limit2] = sum / Shuffle;
      sum -= Bands[limit2 + Shuffle - 1];
      limit2--;
   }
   if (shift1 < 1) for (k = 1; k < Shuffle; k++) Base_Signal[Bars - k] = 0;
}

//+-----------------------------------------------------------------------+

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,0,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//+-----------------------------------------------------------------------+

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",tf," GoldBands : direction changed to ",doWhat);
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(message,message+"\nLocal time "+TimeToStr(TimeLocal(),TIME_SECONDS)+""+"\nBroker time "+TimeToStr(TimeCurrent(),TIME_SECONDS));
          if (AlertsSound)   PlaySound("alert.wav");
   }
}

//--------------------------------------------Xard@hotmail.co.uk-----+
/*
                                                            
                                                          
                              ud$$$**$$$$$$$bc.                          
                          u@**"        4$$$$$$$Nu                       
                        J                ""#$$$$$$r                     
                       @                       $$$$b                    
                     .F                        ^*3$$$                   
                    :% 4                         J$$$N                  
                    $  :F                       :$$$$$                  
                   4F  9                       J$$$$$$$                 
                   4$   k             4$$$$bed$$$$$$$$$                 
                   $$r  'F            $$$$$$$$$$$$$$$$$r                
                   $$$   b.           $$$$$$$$$$$$$$$$$N                
                   $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
    .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
    :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
   @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
   $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
   $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
    ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
       ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
            ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
              ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                   #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                     "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                       "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                         ?k         ?$$$$$$$$$$$F'*                     
                          9$$bL     z$$$$$$$$$$$F                       
                           $$$$    $$$$$$$$$$$$$                        
                            '#$$c  '$$$$$$$$$"                          
                             .@"#$$$$$$$$$$$$b                          
                           z*      $$$$$$$$$$$$N.                       
                         e"      z$$"  #$$$k  '*$$.                     
                     .u*      u@$P"      '#$$c   "$$c                   
              u@$*"""       d$$"            "$$$u  ^*$$b.               
            :$F           J$P"                ^$$$c   '"$$$$$$bL        
           d$$  ..      @$#                      #$$b         '#$       
           9$$$$$$b   4$$                          ^$$k         '$      
            "$$6""$b u$$                             '$    d$$$$$P      
              '$F $$$$$"                              ^b  ^$$$$b$       
               '$W$$$$"                                'b@$$$$"         
                                                        ^$$$*  
*/            